package com.gxwebsoft.oa.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gxwebsoft.oa.mapper.OaTaskUserMapper;
import com.gxwebsoft.oa.service.OaTaskUserService;
import com.gxwebsoft.oa.entity.OaTaskUser;
import com.gxwebsoft.oa.param.OaTaskUserParam;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.PageResult;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 工单成员Service实现
 *
 * @author 科技小王子
 * @since 2024-09-10 20:57:42
 */
@Service
public class OaTaskUserServiceImpl extends ServiceImpl<OaTaskUserMapper, OaTaskUser> implements OaTaskUserService {

    @Override
    public PageResult<OaTaskUser> pageRel(OaTaskUserParam param) {
        PageParam<OaTaskUser, OaTaskUserParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        List<OaTaskUser> list = baseMapper.selectPageRel(page, param);
        return new PageResult<>(list, page.getTotal());
    }

    @Override
    public List<OaTaskUser> listRel(OaTaskUserParam param) {
        List<OaTaskUser> list = baseMapper.selectListRel(param);
        // 排序
        PageParam<OaTaskUser, OaTaskUserParam> page = new PageParam<>();
        page.setDefaultOrder("create_time desc");
        return page.sortRecords(list);
    }

    @Override
    public OaTaskUser getByIdRel(Integer taskUserId) {
        OaTaskUserParam param = new OaTaskUserParam();
        param.setTaskUserId(taskUserId);
        return param.getOne(baseMapper.selectListRel(param));
    }

}
